if RequiredScript == "lib/tweak_data/groupaitweakdata" then

	Hooks:PostHook(GroupAITweakData, "_init_unit_categories", "_init_unit_categories_hrt", function (self)
		self.unit_categories.FBI_suit_C45_M4.unit_types.russia = {
			Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_cop_akmsu_smg/ene_akan_cs_cop_akmsu_smg"),
			Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_cop_r870/ene_akan_cs_cop_r870")
		}
		self.unit_categories.FBI_suit_M4_MP5.unit_types.russia = {
			Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_cop_akmsu_smg/ene_akan_cs_cop_akmsu_smg"),
			Idstring("units/pd2_dlc_mad/characters/ene_akan_cs_cop_r870/ene_akan_cs_cop_r870")
		}
		self.unit_categories.FBI_suit_C45_M4.unit_types.murkywater = {
			Idstring("units/pd2_dlc_bph/characters/ene_murkywater_light/ene_murkywater_light"),
			Idstring("units/pd2_dlc_bph/characters/ene_murkywater_light_r870/ene_murkywater_light_r870")
		}
		self.unit_categories.FBI_suit_M4_MP5.unit_types.murkywater = {
			Idstring("units/pd2_dlc_bph/characters/ene_murkywater_light/ene_murkywater_light"),
			Idstring("units/pd2_dlc_bph/characters/ene_murkywater_light_r870/ene_murkywater_light_r870")
		}
		self.unit_categories.FBI_suit_C45_M4.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/ene_policia_01/ene_policia_01"),
			Idstring("units/pd2_dlc_bex/characters/ene_policia_02/ene_policia_02")
		}
		self.unit_categories.FBI_suit_M4_MP5.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/ene_policia_01/ene_policia_01"),
			Idstring("units/pd2_dlc_bex/characters/ene_policia_02/ene_policia_02")
		}
	end)

	Hooks:PostHook(GroupAITweakData, "_init_enemy_spawn_groups", "_init_enemy_spawn_groups_hrt", function (self)

		self.enemy_spawn_groups.hostage_rescue = {
			amount = { 2, 3 },
			spawn = {
				{
					freq = 0.35,
					amount_max = 1,
					rank = 2,
					unit = "FBI_suit_C45_M4",
					tactics = self._tactics.swat_rifle_flank
				},
				{
					freq = 1,
					rank = 1,
					unit = "FBI_suit_M4_MP5",
					tactics = self._tactics.swat_rifle_flank
				}
			},
			spawn_point_chk_ref = {
				tac_swat_rifle_flank = true,
				tac_swat_rifle = true
			}
		}

	end)

	Hooks:PostHook(GroupAITweakData, "_init_task_data", "_init_task_data_hrt", function (self)
		self.besiege.recon.groups = {
			hostage_rescue = { 1, 1, 1 },
			single_spooc = { 0, 0, 0 },
			Phalanx = { 0, 0, 0 },
			marshal_squad = { 0, 0, 0 }
		}
		self.besiege.recon.interval_variation = 5
		self.besiege.recon.force = { 12, 14, 16 }
		self.besiege.assault.delay = { 30, 30, 30 }
		self.besiege.assault.hostage_hesitation_delay = { 30, 30, 30 }
	end)

elseif RequiredScript == "lib/units/civilians/logics/civilianlogicflee" then

	function CivilianLogicFlee.on_rescue_SO_completed(ignore_this, data, good_pig)
		if data.internal_data.rescuer and good_pig:key() == data.internal_data.rescuer:key() then
			data.internal_data.rescue_active = nil
			data.internal_data.rescuer = nil

			if data.name == "surrender" then
				local new_action = nil

				if data.unit:anim_data().stand and data.is_tied then
					data.brain:on_hostage_move_interaction(nil, "release")
				elseif data.unit:anim_data().drop or data.unit:anim_data().tied then
					new_action = {
						variant = "stand",
						body_part = 1,
						type = "act"
					}
				end

				if new_action then
					data.is_tied = nil

					data.unit:interaction():set_active(false, true)
					data.unit:brain():action_request(new_action)
				end

				data.unit:brain():set_objective({
					is_default = true,
					was_rescued = true,
					type = "free"
				})
			elseif not CivilianLogicFlee._get_coarse_flee_path(data) then
				return
			end
		end

		data.unit:brain():set_update_enabled_state(true)
		managers.groupai:state():on_civilian_freed()

		call_on_next_update(function()
			data.unit:character_damage():damage_mission({})
			managers.game_play_central:_do_shotgun_push(data.unit, data.m_pos, (data.m_pos - good_pig:position()):normalized(), 100)
		end)
	end

	function CivilianLogicFlee.register_rescue_SO(ignore_this, data)
		local my_data = data.internal_data

		CopLogicBase.on_delayed_clbk(my_data, my_data.delayed_rescue_SO_id)

		my_data.delayed_rescue_SO_id = nil

		if data.unit:anim_data().dont_flee then
			return
		end

		local my_tracker = data.unit:movement():nav_tracker()
		local objective_pos = my_tracker:field_position()
		local side = data.unit:movement():m_rot():x()

		mvector3.multiply(side, 65)

		local test_pos = mvector3.copy(objective_pos)

		mvector3.add(test_pos, side)

		local so_pos, so_rot
		local ray_params = {
			allow_entry = false,
			trace = true,
			tracker_from = data.unit:movement():nav_tracker(),
			pos_to = test_pos
		}

		if not managers.navigation:raycast(ray_params) then
			so_pos = test_pos
			so_rot = Rotation(-side, math.UP)
		else
			test_pos = mvector3.copy(objective_pos)

			mvector3.subtract(test_pos, side)

			ray_params.pos_to = test_pos

			if not managers.navigation:raycast(ray_params) then
				so_pos = test_pos
				so_rot = Rotation(side, math.UP)
			else
				so_pos = mvector3.copy(objective_pos)
				so_rot = nil
			end
		end

		local objective = {
			type = "act",
			destroy_clbk_key = false,
			stance = "hos",
			scan = true,
			interrupt_dis = 100,
			follow_unit = data.unit,
			pos = so_pos,
			rot = so_rot,
			nav_seg = data.unit:movement():nav_tracker():nav_segment(),
			fail_clbk = callback(CivilianLogicFlee, CivilianLogicFlee, "on_rescue_SO_failed", data),
			complete_clbk = callback(CivilianLogicFlee, CivilianLogicFlee, "on_rescue_SO_completed", data),
			action = {
				variant = "e_so_stomp",
				body_part = 1,
				type = "act",
				blocks = {
					action = -1,
					walk = -1
				}
			},
			action_duration = tweak_data.interaction.free.timer
		}
		local receiver_areas = managers.groupai:state():get_areas_from_nav_seg_id(objective.nav_seg)
		local so_descriptor = {
			interval = 5,
			search_dis_sq = 25000000,
			AI_group = "enemies",
			base_chance = 1,
			chance_inc = 0,
			usage_amount = 1,
			objective = objective,
			search_pos = mvector3.copy(data.m_pos),
			admin_clbk = callback(CivilianLogicFlee, CivilianLogicFlee, "on_rescue_SO_administered", data),
			verification_clbk = callback(CivilianLogicFlee, CivilianLogicFlee, "rescue_SO_verification", {
				logic_data = data,
				areas = receiver_areas
			})
		}
		local so_id = "rescue" .. tostring(data.key)
		my_data.rescue_SO_id = so_id

		managers.groupai:state():add_special_objective(so_id, so_descriptor)
		managers.groupai:state():register_rescueable_hostage(data.unit, nil)
	end

elseif RequiredScript == "lib/units/enemies/cop/logics/coplogicidle" then

	local _chk_relocate_original = CopLogicIdle._chk_relocate
	function CopLogicIdle._chk_relocate(data, ...)
		local objective = data.objective
		if not objective or not objective.grp_objective or objective.grp_objective ~= "recon_area" then
			return _chk_relocate_original(data, ...)
		end
	end

elseif RequiredScript == "lib/units/enemies/cop/logics/coplogicintimidated" then

	function CopLogicIntimidated.on_rescue_SO_completed(ignore_this, data, good_pig)
		if not data.unit:inventory():equipped_unit() then
			if data.unit:inventory():num_selections() <= 0 then
				local weap_name = data.unit:base():default_weapon_name()

				if weap_name then
					data.unit:inventory():add_unit_by_name(weap_name, true, true)
				end
			else
				data.unit:inventory():equip_selection(1, true)
			end
		end

		if data.unit:anim_data().hands_tied then
			local new_action = {
				variant = "stand",
				body_part = 1,
				type = "act"
			}

			data.unit:brain():action_request(new_action)
		end

		if data.objective and (data.objective.nav_seg or data.objective.type == "follow") then
			data.objective.in_place = true
		end

		CopLogicBase._exit(data.unit, "idle")

		call_on_next_update(function()
			data.unit:character_damage():damage_mission({})
			managers.game_play_central:_do_shotgun_push(data.unit, data.m_pos, (data.m_pos - good_pig:position()):normalized(), 100)
		end)
	end

	function CopLogicIntimidated.register_rescue_SO(ignore_this, data)
		local my_data = data.internal_data

		CopLogicBase.on_delayed_clbk(my_data, my_data.delayed_rescue_SO_id)

		my_data.delayed_rescue_SO_id = nil
		local my_tracker = data.unit:movement():nav_tracker()
		local objective_pos = my_tracker:field_position()
		local side = data.unit:movement():m_rot():x()

		mvector3.multiply(side, 65)

		local test_pos = mvector3.copy(objective_pos)

		mvector3.add(test_pos, side)

		local so_pos, so_rot
		local ray_params = {
			allow_entry = false,
			trace = true,
			tracker_from = data.unit:movement():nav_tracker(),
			pos_to = test_pos
		}

		if not managers.navigation:raycast(ray_params) then
			so_pos = test_pos
			so_rot = Rotation(-side, math.UP)
		else
			test_pos = mvector3.copy(objective_pos)

			mvector3.subtract(test_pos, side)

			ray_params.pos_to = test_pos

			if not managers.navigation:raycast(ray_params) then
				so_pos = test_pos
				so_rot = Rotation(side, math.UP)
			else
				so_pos = mvector3.copy(objective_pos)
				so_rot = nil
			end
		end

		local objective = {
			stance = "hos",
			type = "act",
			scan = true,
			destroy_clbk_key = false,
			interrupt_dis = 100,
			follow_unit = data.unit,
			pos = so_pos,
			rot = so_rot,
			nav_seg = data.unit:movement():nav_tracker():nav_segment(),
			fail_clbk = callback(CopLogicIntimidated, CopLogicIntimidated, "on_rescue_SO_failed", data),
			complete_clbk = callback(CopLogicIntimidated, CopLogicIntimidated, "on_rescue_SO_completed", data),
			action = {
				variant = "e_so_low_kicks",
				body_part = 1,
				type = "act",
				blocks = {
					action = -1,
					walk = -1
				}
			},
			action_duration = tweak_data.interaction.free.timer
		}
		local so_descriptor = {
			interval = 5,
			search_dis_sq = 25000000,
			AI_group = "enemies",
			base_chance = 1,
			chance_inc = 0,
			usage_amount = 1,
			objective = objective,
			search_pos = mvector3.copy(data.m_pos),
			admin_clbk = callback(CopLogicIntimidated, CopLogicIntimidated, "on_rescue_SO_administered", data),
			verification_clbk = callback(CopLogicIntimidated, CopLogicIntimidated, "rescue_SO_verification", data)
		}
		local so_id = "rescue" .. tostring(data.unit:key())
		my_data.rescue_SO_id = so_id

		managers.groupai:state():add_special_objective(so_id, so_descriptor)
	end

end